Refactor and add cache

This commit is contained in:
Santiago Lo Coco 2024-04-09 22:23:10 +02:00
parent 1ef1a7825b
commit f2c0820ef2
2 changed files with 111 additions and 91 deletions

View File

@ -13,7 +13,7 @@ $(INSTALL_PATH): cbattery
uninstall: uninstall:
@echo "Removing cbattery from $(DESTDIR)" @echo "Removing cbattery from $(DESTDIR)"
@$(DESTDIR)/cbattery revert || (echo "Reverting cbattery configurations failed"; exit 1) @su $(USER) -c '$(DESTDIR)/cbattery revert' || (echo "Reverting cbattery configurations failed"; exit 1)
@rm -f $(INSTALL_PATH) @rm -f $(INSTALL_PATH)
help: help:

200
cbattery
View File

@ -2,119 +2,139 @@
set -e set -e
function usage() { CACHE_FILE="${XDG_CACHE_HOME:-$HOME/.cache}/cbattery.status"
cat << EOF
usage() {
cat << EOF
usage: ${0##*/} [command] usage: ${0##*/} [command]
charging [on|off] - Toggle charging charging [on|off] - Toggle charging
adapter [on|off] - Toggle adapter connection adapter [on|off] - Toggle adapter connection
status - Get status information status - Get status information
revert - Revert to default settings revert - Revert to default settings
visudo - Run the script without password visudo - Run the script without password
help - Display this help message help - Display this help message
EOF EOF
} }
function enable_discharging() { write_cache() {
echo "Enabling battery discharging" echo "$1" > "$CACHE_FILE"
sudo smc -k CH0I -w 01
} }
function disable_discharging() { read_cache() {
echo "Disabling battery discharging" cat "$CACHE_FILE" 2> /dev/null
sudo smc -k CH0I -w 00
} }
function enable_charging() { enable_discharging() {
echo "Enabling battery charging" echo "Enabling battery discharging"
sudo smc -k CH0B -w 00 sudo smc -k CH0I -w 01
sudo smc -k CH0C -w 00
disable_discharging
} }
function disable_charging() { disable_discharging() {
echo "Disabling battery charging" echo "Disabling battery discharging"
sudo smc -k CH0B -w 02 sudo smc -k CH0I -w 00
sudo smc -k CH0C -w 02
} }
function get_smc_charging_hex() { enable_charging() {
smc -k CH0B -r | awk '{print $4}' | sed s:\):: echo "Enabling battery charging"
sudo smc -k CH0B -w 00
sudo smc -k CH0C -w 00
disable_discharging
write_cache "enabled"
} }
function get_smc_charging_status() { disable_charging() {
hex_status=$(get_smc_charging_hex) echo "Disabling battery charging"
if [[ "$hex_status" == "00" ]]; then sudo smc -k CH0B -w 02
echo "enabled" sudo smc -k CH0C -w 02
else write_cache "disabled"
echo "disabled"
fi
} }
function get_battery_percentage() { get_smc_charging_hex() {
battery_percentage=$(pmset -g batt | tail -n1 | awk '{print $3}' | sed s:%\;::) smc -k CH0B -r | awk '{print $4}' | sed s:\)::
echo "$battery_percentage"
} }
function install_visudo_file() { get_smc_charging_status() {
sudoers_file="/private/etc/sudoers.d/cbattery" hex_status=$(get_smc_charging_hex)
if ! smc_loc="$(command -v smc)"; then [[ "$hex_status" == "00" ]] && echo "enabled" || echo "disabled"
echo "'smc' is required but not found."
exit 1
fi
sed "s:smc:$smc_loc:g" ".visudo" | sudo tee "$sudoers_file" > /dev/null
if ! sudo visudo -c -f "$sudoers_file"; then
echo "Failed to check sudoers file syntax."
sudo rm "$sudoers_file"
exit 1
fi
sudo chmod 440 "$sudoers_file"
} }
action=$1 get_battery_percentage() {
setting=$2 pmset -g batt | awk 'END {print $3}' | sed 's/%;//'
}
if [ -z "$action" ] || [[ "$action" == "help" ]]; then install_visudo_file() {
usage sudoers_file="/private/etc/sudoers.d/cbattery"
exit 0 if ! smc_loc="$(command -v smc)"; then
fi echo "'smc' is required but not found."
exit 1
fi
sed "s:smc:$smc_loc:g" ".visudo" | sudo tee "$sudoers_file" > /dev/null
if ! sudo visudo -c -f "$sudoers_file"; then
echo "Failed to check sudoers file syntax."
sudo rm "$sudoers_file"
exit 1
fi
sudo chmod 440 "$sudoers_file"
}
if [[ "$action" == "revert" ]]; then get_cached_status() {
enable_charging set +e
disable_discharging read_cache_result=$(read_cache)
exit 0 read_cache_error=$?
fi set -e
if [ $read_cache_error -ne 0 ]; then
status=$(get_smc_charging_status)
write_cache "$status"
echo "$status"
else
echo "$read_cache_result"
fi
}
if [[ "$action" == "charging" ]]; then runScript() {
echo "Setting $action to $setting" action=$1
if [[ "$setting" == "on" ]]; then setting=$2
enable_charging
elif [[ "$setting" == "off" ]]; then
disable_charging
fi
exit 0
fi
if [[ "$action" == "adapter" ]]; then case "$action" in
echo "Setting $action to $setting" "help" | "")
if [[ "$setting" == "on" ]]; then usage
enable_discharging ;;
elif [[ "$setting" == "off" ]]; then "revert")
disable_discharging enable_charging
fi disable_discharging
exit 0 ;;
fi "charging")
echo "Setting $action to $setting"
case "$setting" in
"on") enable_charging ;;
"off") disable_charging ;;
*) echo "Invalid option: $setting" ;;
esac
;;
"adapter")
echo "Setting $action to $setting"
case "$setting" in
"on") enable_discharging ;;
"off") disable_discharging ;;
*) echo "Invalid option: $setting" ;;
esac
;;
"status")
case "$setting" in
"charging") exit "$(get_smc_charging_hex)" ;;
"cache") echo "$(get_cached_status)" ;;
*) echo "Battery at $(get_battery_percentage)%, smc charging $(get_smc_charging_status)" ;;
esac
;;
"visudo")
install_visudo_file
;;
*)
echo "Invalid command: $action"
usage
;;
esac
}
if [[ "$action" == "status" ]]; then runScript "$@"
if [[ "$setting" == "charging" ]]; then
exit "$(get_smc_charging_hex)"
else
echo "Battery at $(get_battery_percentage)%, smc charging $(get_smc_charging_status)"
fi
exit 0
fi
if [[ "$action" == "visudo" ]]; then
install_visudo_file
exit 0
fi